package  
{
	import flash.net.drm.VoucherAccessInfo;
	import net.flashpunk.World;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	
	/**
	 * ...
	 * @author Benn
	 */
	public class GameWorld extends World 
	{
		
		[Embed(source = "../assets/audio/ld33.mp3")] private static const MUSIC:Class;
		[Embed(source = "../assets/audio/windup.mp3")] private static const WINDUP:Class;
		
		private var Music:Sfx = new Sfx(MUSIC);
		private var WindupSfx:Sfx = new Sfx(WINDUP);
		private var GameTime : Number = 0;
		
		private var InTitleScreen : Boolean = true;
		private var InSuccessScreen : Boolean = false;
		private var CurrentLevel : int = 0;
		
		private var BackgroundRects : Array = [];
		private var CollisionRects : Array = [];
		private var GameText : Array = [];
		private var SquareGoals : Array = [];
		private var SquareDoubleJumps : Array = [];
		private var GamePlayer : PlayerBall;
		private var GameState : int = 0;  //0 - unlaunched, 1 - punted, 2 - freemove
		
		private var UnlaunchedMouseDown : Boolean = false;
		private var PuntStrength : Number = 0;
		private var PuntBarSpeed : Number = 1.5;
		private var PuntDirection : Boolean = true;
		
		private var InSlowMotion : Boolean = false;
		private var ArrowRadius : int = 100;
		
		private var FireStrength : Number = 0;
		private var FireBarSpeed : Number = 6.0;
		
		private var ResetTimer : Number = 0;
		private var ResetText : HudText;
		
		public function GameWorld() 
		{
			
			Music.loop(0.8);
			
			var newBackgroundObject : Backgroundobjects = new Backgroundobjects(true);
			add(newBackgroundObject);
			BackgroundRects.push(newBackgroundObject);
			
			newBackgroundObject = new Backgroundobjects(false);
			add(newBackgroundObject);
			BackgroundRects.push(newBackgroundObject);
			
			newBackgroundObject = new Backgroundobjects(true);
			add(newBackgroundObject);
			BackgroundRects.push(newBackgroundObject);
			
			newBackgroundObject = new Backgroundobjects(false);
			add(newBackgroundObject);
			BackgroundRects.push(newBackgroundObject);
			
			newBackgroundObject = new Backgroundobjects(true);
			add(newBackgroundObject);
			BackgroundRects.push(newBackgroundObject);
			
			newBackgroundObject = new Backgroundobjects(false);
			add(newBackgroundObject);
			BackgroundRects.push(newBackgroundObject);
			
			ResetText = new HudText("Press space to reset");
			ResetText.x = 225;
			ResetText.y = 300;
			add(ResetText);
			ResetText.visible = false;
			
			LoadTitleScreen();
			
		}
		
		private function LoadVictoryScreen():void
		{
			
			var Text1 : HudText = new HudText("Thanks for playing!");
			Text1.x = 96;
			Text1.y = 96;
			Text1.SetSize(30);
			add(Text1);
			GameText.push(Text1);
			
			var Text4 : HudText = new HudText("Finished in - " + GameTime.toFixed(3) + " seconds");
			Text4.x = 96;
			Text4.y = 150;
			add(Text4);
			GameText.push(Text4);
			
			var Text2 : HudText = new HudText("Let me know what you think on Twitter - @bennpowell");
			Text2.x = 96;
			Text2.y = 186;
			add(Text2);
			GameText.push(Text2);
			
			var Text3 : HudText = new HudText("Check out my other games at benn-gaming.co.uk");
			Text3.x = 96;
			Text3.y = 218;
			add(Text3);
			GameText.push(Text3);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 640, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);
			
		}
		
		private function LoadTitleScreen():void
		{
			
			var Text1 : HudText = new HudText("ORANGE SQUARES...");
			Text1.x = 96;
			Text1.y = 96;
			Text1.SetSize(50);
			add(Text1);
			GameText.push(Text1);
			
			var Text2 : HudText = new HudText("BEWARE!");
			Text2.x = 96;
			Text2.y = 160;
			Text2.SetColour(0xBD2E23);
			Text2.SetSize(50);
			add(Text2);
			GameText.push(Text2);
			
			var Text3 : HudText = new HudText("An artistically challenged game by Benn Powell");
			Text3.x = 96;
			Text3.y = 288;
			add(Text3);
			GameText.push(Text3);
			
			var Text4 : HudText = new HudText("Created in 48 hours for Ludum Dare 33");
			Text4.x = 96;
			Text4.y = 320;
			add(Text4);
			GameText.push(Text4);
			
			var Text5 : HudText = new HudText("Press SPACE to begin");
			Text5.x = 96;
			Text5.y = 352;
			add(Text5);
			GameText.push(Text5);
		
			
		}
		
		private function CleanUpTitleScreen():void
		{
			
			for each (var T:HudText in GameText)
			{
				remove(T);
			}
			
			GameText.length = 0;
			
		}
		
		private function LoadLevel():void
		{
			if (CurrentLevel == 1)
			{
				CreateLevelOne();
			}
			else if (CurrentLevel == 2)
			{
				CreateLevelTwo();
			}
			else if (CurrentLevel == 3)
			{
				CreateLevelThree();
			}
			else if (CurrentLevel == 4)
			{
				CreateLevelFour();
			}
			else if (CurrentLevel == 5)
			{
				CreateLevelFive();
			}
			else if (CurrentLevel == 6)
			{
				CreateLevelSix();
			}
			else if (CurrentLevel == 7)
			{
				CreateLevelSeven();
			}
			else if (CurrentLevel == 8)
			{
				CreateLevelEight();
			}
			else if (CurrentLevel == 9)
			{
				CreateLevelNine();
			}
			else if (CurrentLevel == 10)
			{
				CreateLevelTen();
			}
			else
			{
				LoadVictoryScreen();
				InSuccessScreen = true;
			}
			
		}
		
		private function CreateLevelOne():void
		{
			
			var tutText : HudText = new HudText("Click and hold the mouse to punt the ball");
			tutText.x = 30;
			tutText.y = 30;
			add(tutText);
			GameText.push(tutText);
			
			var tutText2 : HudText = new HudText("Then click and hold in midair to fire in the direction of the mouse");
			tutText2.x = 30;
			tutText2.y = 60;
			add(tutText2);
			GameText.push(tutText2);
			
			GamePlayer = new PlayerBall(100, 440);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 160, 32, 0x28ACE1); //bottom left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(480, 464, 160, 32, 0x28ACE1); //bottom right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(528, 368, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
		}
		
		private function CreateLevelTwo():void
		{
			
			GamePlayer = new PlayerBall(100, 440);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 512, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(256, 0, 32, 304, 0x28ACE1); //middle
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(288, 272, 144, 32, 0x28ACE1); //middle
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(320, 176, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
		}
		
		private function CreateLevelThree():void
		{
			
			GamePlayer = new PlayerBall(100, 440);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 176, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(496, 464, 144, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);

			newCollider = new WorldRect(176, 112, 32, 368, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(288, 112, 128, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(496, 112, 32, 368, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(544, 384, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
		}
		
		private function CreateLevelFour():void
		{
			
			GamePlayer = new PlayerBall(80, 440);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 128, 32, 0x28ACE1); //bottomleft
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(496, 464, 128, 32, 0x28ACE1); //bottomright
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(144, 112, 32, 368, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(304, 16, 32, 160, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(464, 240, 32, 240, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(528, 368, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
			var doublejumpone : SquareDoubleJump = new SquareDoubleJump(240, 128);
			add(doublejumpone);
			SquareDoubleJumps.push(doublejumpone);
			
			var tutText : HudText = new HudText("Green squares will give you");
			tutText.x = 195;
			tutText.y = 400;
			add(tutText);
			GameText.push(tutText);
			
			var tutText2 : HudText = new HudText("an additional midair shot");
			tutText2.x = 195;
			tutText2.y = 430;
			add(tutText2);
			GameText.push(tutText2);
			
		}
		
		private function CreateLevelFive():void
		{
			
			GamePlayer = new PlayerBall(68, 396);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(16, 416, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(144, 112, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(272, 416, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(400, 112, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(528, 416, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);

			var goalone : SquareGoal = new SquareGoal(160, 32, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
			var goaltwo : SquareGoal = new SquareGoal(288, 336, 64);
			add(goaltwo);
			SquareGoals.push(goaltwo);
			
			var goalthree : SquareGoal = new SquareGoal(416, 32, 64);
			add(goalthree);
			SquareGoals.push(goalthree);
			
			var goalfour : SquareGoal = new SquareGoal(544, 336, 64);
			add(goalfour);
			SquareGoals.push(goalfour);
			
		}
		
		private function CreateLevelSix():void
		{
			
			GamePlayer = new PlayerBall(68, 396);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(0, 0, 640, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);

			newCollider = new WorldRect(16, 416, 96, 64, 0x28ACE1); //launch platform
			CollisionRects.push(newCollider);
			add(newCollider);

			newCollider = new WorldRect(176, 336, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(176, 336, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(288, 224, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(400, 336, 96, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(320, 16, 32, 208, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(208, 368, 32, 112, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(432, 368, 32, 112, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalthree : SquareGoal = new SquareGoal(416, 80, 32);
			add(goalthree);
			SquareGoals.push(goalthree);
			
			var doublejumpone : SquareDoubleJump = new SquareDoubleJump(528, 256);
			add(doublejumpone);
			SquareDoubleJumps.push(doublejumpone);
			
		}
		
		private function CreateLevelSeven():void
		{
			
			GamePlayer = new PlayerBall(100, 430);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 304, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(176, 112, 32, 352, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(208, 112, 320, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(288, 304, 32, 160, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
		
			var goalthree : SquareGoal = new SquareGoal(224, 400, 48);
			add(goalthree);
			SquareGoals.push(goalthree);
			
			var doublejumpone : SquareDoubleJump = new SquareDoubleJump(560, 112);
			add(doublejumpone);
			SquareDoubleJumps.push(doublejumpone);
			
		}
		
		private function CreateLevelEight():void
		{
			
			GamePlayer = new PlayerBall(85, 440);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(0, 0, 16, 480, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(624, 0, 16, 480, 0x28ACE1); //right
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 464, 160, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(16, 0, 624, 16, 0x28ACE1); //top
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(192, 16, 32, 224, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(192, 208, 160, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(352, 80, 32, 160, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(256, 126, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
			var doublejumpone : SquareDoubleJump = new SquareDoubleJump(304, 272);
			add(doublejumpone);
			SquareDoubleJumps.push(doublejumpone);
			
			var doublejumptwo : SquareDoubleJump = new SquareDoubleJump(480, 128);
			add(doublejumptwo);
			SquareDoubleJumps.push(doublejumptwo);
			
		}
		
		private function CreateLevelNine():void
		{
			
			GamePlayer = new PlayerBall(550, 440);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(464, 464, 180, 32, 0x28ACE1); //bottom
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(240, 144, 128, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(240, 272, 128, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(240, 400, 128, 32, 0x28ACE1);
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(272, 64, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
			var goaltwo : SquareGoal = new SquareGoal(272, 192, 64);
			add(goaltwo);
			SquareGoals.push(goaltwo);
			
			var goalthree : SquareGoal = new SquareGoal(272, 320, 64);
			add(goalthree);
			SquareGoals.push(goalthree);
			
			var doublejumpone : SquareDoubleJump = new SquareDoubleJump(176, 336);
			add(doublejumpone);
			SquareDoubleJumps.push(doublejumpone);
			
			var doublejumptwo : SquareDoubleJump = new SquareDoubleJump(400, 208);
			add(doublejumptwo);
			SquareDoubleJumps.push(doublejumptwo);
			
		}
		
		private function CreateLevelTen():void
		{
			
			GamePlayer = new PlayerBall(325, 400);
			add(GamePlayer);
			
			var newCollider : WorldRect = new WorldRect(304, 448, 32, 32, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			newCollider = new WorldRect(272, 416, 96, 32, 0x28ACE1); //left
			CollisionRects.push(newCollider);
			add(newCollider);
			
			var goalone : SquareGoal = new SquareGoal(480, 336, 64);
			add(goalone);
			SquareGoals.push(goalone);
			
			var goaltwo : SquareGoal = new SquareGoal(176, 80, 64);
			add(goaltwo);
			SquareGoals.push(goaltwo);
			
			var goalthree : SquareGoal = new SquareGoal(96, 336, 64);
			add(goalthree);
			SquareGoals.push(goalthree);
			
			var doublejumpone : SquareDoubleJump = new SquareDoubleJump(416, 96);
			add(doublejumpone);
			SquareDoubleJumps.push(doublejumpone);
			
		}
		
		private function CleanUp():void
		{
			
			remove(GamePlayer);
			
			for each (var W:WorldRect in CollisionRects)
			{
				remove(W);
			}
			
			CollisionRects.length = 0;
			
			for each (var S:SquareGoal in SquareGoals)
			{
				remove(S);
			}
			
			SquareGoals.length = 0;
			
			for each (var D:SquareDoubleJump in SquareDoubleJumps)
			{
				remove(D);
			}
			
			SquareDoubleJumps.length = 0;
			
			for each (var T:HudText in GameText)
			{
				remove(T);
			}
			
			GameText.length = 0;
			
			UnlaunchedMouseDown = false;
			PuntStrength = 0;
			FireStrength = 0;
			GameState = 0;
			
			ResetText.visible = false;
			ResetTimer = 0;
			
		}
		
		private function UpdateUnlaunched():void
		{
			
			if (UnlaunchedMouseDown == false)
			{			
				if (Input.mousePressed)
				{
					UnlaunchedMouseDown = true;
				}
			}
			else if (Input.mouseReleased)
			{
				GamePlayer.Punt(PuntStrength);
				GameState = 1;
				UnlaunchedMouseDown = false;
				PuntStrength = 0;
			}
			else
			{
				if (PuntDirection == true)
				{
					
					PuntStrength += PuntBarSpeed * FP.elapsed;
					
					if (PuntStrength > 1)
					{
						PuntStrength = 1;
						PuntDirection = false;
					}
					
				}
				else
				{
					
					PuntStrength -= PuntBarSpeed * FP.elapsed;
					
					if (PuntStrength < 0.01)
					{
						PuntStrength = 0.01;
						PuntDirection = true;
					}
					
				}
			}

		}
		
		private function UpdatePunt():void
		{
			
			if (GamePlayer.GetState() == 0)
			{
				WindupSfx.stop();
				FP.rate = 1.0;
				GameState = 0;
				InSlowMotion = false;
				FireStrength = 0;
			}
			else if (GamePlayer.GetState() == 1)
			{
				if (Input.mousePressed)
				{
					WindupSfx.play();
					FireStrength = 0;
					InSlowMotion = true;
					FP.rate = 0.1;
				}
				else if (Input.mouseReleased)
				{
					WindupSfx.stop();
					InSlowMotion = false;
					FP.rate = 1.0;
					GameState = 2;
					GamePlayer.Fire(FireStrength);
				}
				
				if (InSlowMotion)
				{

					FireStrength += FireBarSpeed * FP.elapsed;
					
					if (FireStrength > 1)
					{
						WindupSfx.stop();
						FireStrength = 1;
						InSlowMotion = false;
						FP.rate = 1.0;
						GameState = 2;
						GamePlayer.Fire(FireStrength);
					}

				}
				
			}
			
		}
		
		public function UpdateFreemove():void
		{	
			
			if (GamePlayer.GetState() == 0 || Input.released(Key.SPACE))
			{
				WindupSfx.stop();
				InSlowMotion = false;
				FP.rate = 1.0;
				CleanUp();
				LoadLevel();
			}
			else
			{
				
				ResetTimer += FP.elapsed;
				
				if (ResetTimer > 5)
				{
					ResetText.visible = true;
				}
				
				var IsAllDead : Boolean = true;
				
				for each (var S : SquareGoal in SquareGoals)
				{
					if (S.GetDead() == false)
					{
						IsAllDead = false;
					}
				}
				
				if (IsAllDead)
				{
					CleanUp();
					CurrentLevel++;
					LoadLevel();
					return;
				}
				
				if (GamePlayer.GetCanDoubleJump())
				{
					if (Input.mousePressed)
					{
						WindupSfx.play();
						FireStrength = 0;
						InSlowMotion = true;
						FP.rate = 0.1;
					}
					else if (Input.mouseReleased)
					{
						if (InSlowMotion)
						{
							WindupSfx.stop();
							InSlowMotion = false;
							FP.rate = 1.0;
							GameState = 2;
							GamePlayer.Fire(FireStrength);
							FireStrength = 0;
						}	
					}
					
					if (InSlowMotion)
					{
						FireStrength += FireBarSpeed * FP.elapsed;
						
						if (FireStrength > 1)
						{
							WindupSfx.stop();
							FireStrength = 1;
							InSlowMotion = false;
							FP.rate = 1.0;
							GameState = 2;
							GamePlayer.Fire(FireStrength);
							FireStrength = 0;
						}
					}
				}
			}
		}
		
		override public function update():void 
		{
			
			if (Input.released(Key.M))
			{
				if (Music.playing)
				{
					Music.stop();
				}
				else
				{
					Music.loop();
				}
			}
			
			if (InTitleScreen)
			{
				if (Input.pressed(Key.SPACE))
				{
					CleanUpTitleScreen();
					CurrentLevel = 1;
					InTitleScreen = false;
					LoadLevel();
				}
				super.update();
				return;
			}
			else if (InSuccessScreen)
			{
				super.update();
				return;
			}
			
			if (InSlowMotion)
			{
				GameTime += FP.elapsed * 10;
			}
			else
			{
				GameTime += FP.elapsed;
			}
			
			if (GameState == 0)
			{
				UpdateUnlaunched();
			}
			else if (GameState == 1)
			{
				UpdatePunt();
			}
			else
			{	
				UpdateFreemove();
			}
			
			super.update();
			
		}
	
		override public function render():void 
		{
			
			Draw.rect(0, 0, 640, 480, 0x11455B);
			
			Draw.rect(0, 0, 640, 64, 0x145773);
			Draw.rect(0, 416, 640, 64, 0x145773);
			Draw.rect(0, 64, 64, 352, 0x145773);
			Draw.rect(576, 64, 64, 352, 0x145773);
			
			for each (var B : Backgroundobjects in BackgroundRects)
			{
				Draw.rect(B.x, B.y, 64, 128, 0x145773);
			}
			
			if (InTitleScreen)
			{
				super.render();
				return;
			}
			
			for each (var R : WorldRect in CollisionRects)
			{
				Draw.rect(R.x, R.y, R.width, R.height, R.GetColour());
			}		
			
			Draw.circlePlus(GamePlayer.x - 4, GamePlayer.y - 4, 8, 0xFFFFFF);
			
			if (GameState == 0)
			{
				if (UnlaunchedMouseDown)
				{
					Draw.linePlus(GamePlayer.x - 32, GamePlayer.y, GamePlayer.x - 32, GamePlayer.y - (PuntStrength * 400), 0xFF0000, 1, 5);
				}
			}
			
			for each (var S : SquareGoal in SquareGoals)
			{
				if (S.GetDead() == false)
				{
					Draw.rectPlus(S.x, S.y, S.GetSize(), S.GetSize(), 0xEA9D2F, 1, true, 1);
				}	
			}
			
			for each (var D : SquareDoubleJump in SquareDoubleJumps)
			{
				if (D.GetDead() == false)
				{
					Draw.rectPlus(D.x, D.y, 32, 32, 0xABCE30, 1, true, 1);
				}
			}
			
			var directionX : Number = (FP.camera.x + Input.mouseX) - GamePlayer.x;
			var directionY : Number = (FP.camera.y + Input.mouseY) - GamePlayer.y;
		
			//normalize
			var dirDistance : Number = FP.distance(GamePlayer.x - 4, GamePlayer.y - 4, FP.camera.x + Input.mouseX, FP.camera.y + Input.mouseY)
			
			directionX /= dirDistance;
			directionY /= dirDistance;
			
			var endposX : int = GamePlayer.x - 4 + (directionX * (FireStrength * ArrowRadius));
			var endposY : int = GamePlayer.y - 4 + (directionY * (FireStrength * ArrowRadius));
			
			if (InSlowMotion)
			{
				Draw.linePlus(GamePlayer.x - 4, GamePlayer.y - 4, endposX, endposY, 0xFFFFFF, 1, 2);
				Draw.circlePlus(GamePlayer.x - 4, GamePlayer.y - 4, FireStrength * ArrowRadius, 0xFFFFFF, 1, false, 1);
			}
			
			super.render();
			
		}
		
	}

}